#!/bin/bash -x
#
#PJM --rsc-list "node=2"
#PJM --rsc-list "elapse=00:05:00"
#PJM --mpi "rank-map-bynode"
#PJM --mpi "use-rankdir"
#PJM --stgin "rank=* ./platypus_qm %r:./"
#PJM --stgin "rank=* ./qm.inp %r:./"
#PJM --stgin "rank=* ./BASISFILE %r:./"
#PJM -s
#

. /work/system/Env_base

export OMP_NUM_THREADS=8
LPGPARM="lpgparm -s 32MB -d 32MB -h 32MB -t 32MB -p 32MB"

mpiexec ${LPGPARM} ./platypus_qm
