! -*- coding: utf-8 -*-
!
! Dual licensed under the MIT or GPL Version 3 license.
! See 'LICENSE.MIT' for the definition of the MIT license,
! and 'COPYING' for the definition of the GPL license.
!
!** IDIJK  ===========================================================
!  CALUCLATE O_IJK MODEL WITH BLAS FOR DELTA_LM, DPPP TYPE
!====================================================================

       subroutine idijk ( tkw ,   tjv ,   tiu ,  
     &                   dij1,   dij2,   dij3,  
     &                   pij1,   pij2,   pij3     ) 

       implicit double precision (a-h,o-z)
       dimension tiu(9),tkw(9),tjv(9),q1(9)
       dimension dij1(9),dij2(9),dij3(9)
       dimension pij1(9),pij2(9),pij3(9)
       parameter (alpha=1, beta=0 )

       do ii=1,9
        q1(ii) = 0
       enddo
 
 
       call ipgemm (3,q1  ,dij1,tkw)
       call ipgemmt(3,pij1,q1  ,tjv)
 
       call ipgemm (3,q1  ,dij2,tkw)
       call ipgemmt(3,pij2,q1  ,tjv)
  
       call ipgemm (3,q1  ,dij3,tkw)
       call ipgemmt(3,pij3,q1  ,tjv)
 
!      call dgemm('n','n',3,3,3,alpha,dij1,3,tkw,3,beta,q1  ,3)
!      call dgemm('t','n',3,3,3,alpha,q1  ,3,tjv,3,beta,pij1,3)
!      
!      call dgemm('n','n',3,3,3,alpha,dij2,3,tkw,3,beta,q1  ,3)
!      call dgemm('t','n',3,3,3,alpha,q1  ,3,tjv,3,beta,pij2,3)
!      
!      call dgemm('n','n',3,3,3,alpha,dij3,3,tkw,3,beta,q1  ,3)
!      call dgemm('t','n',3,3,3,alpha,q1  ,3,tjv,3,beta,pij3,3)

       dij1(1) = pij1(1)
       dij1(2) = pij1(2)
       dij1(3) = pij1(3)
       dij1(4) = pij2(1)
       dij1(5) = pij2(2)
       dij1(6) = pij2(3)
       dij1(7) = pij3(1)
       dij1(8) = pij3(2)
       dij1(9) = pij3(3)

       dij2(1) = pij1(4)
       dij2(2) = pij1(5)
       dij2(3) = pij1(6)
       dij2(4) = pij2(4)
       dij2(5) = pij2(5)
       dij2(6) = pij2(6)
       dij2(7) = pij3(4)
       dij2(8) = pij3(5)
       dij2(9) = pij3(6)

       dij3(1) = pij1(7)
       dij3(2) = pij1(8)
       dij3(3) = pij1(9)
       dij3(4) = pij2(7)
       dij3(5) = pij2(8)
       dij3(6) = pij2(9)
       dij3(7) = pij3(7)
       dij3(8) = pij3(8)
       dij3(9) = pij3(9)

       call ipgemm (3,pij1,dij1,tiu)
       call ipgemm (3,pij2,dij2,tiu)
       call ipgemm (3,pij3,dij3,tiu)

c      call dgemm('n','n',3,3,3,alpha,dij1,3,tiu,3,beta,pij1,3)
c      call dgemm('n','n',3,3,3,alpha,dij2,3,tiu,3,beta,pij2,3)
c      call dgemm('n','n',3,3,3,alpha,dij3,3,tiu,3,beta,pij3,3)

       return
       end
