! -*- coding: utf-8 -*-
!
! Dual licensed under the MIT or GPL Version 3 license.
! See 'LICENSE.MIT' for the definition of the MIT license,
! and 'COPYING' for the definition of the GPL license.
!
CC JTOUT ============================================================
C  OUTPUT : TABLE OPERATION
C ===================================================================

      subroutine jtout (
     &     index_jtei, val_jtei, njtei1cut, njtei2cut,
     &     iaoslix   , !iaosljx , iaoslkx  , iaosllx  ,
     &     e         ,
     &     iangi     , iangj   , iangk    , iangl    ,
     &     i         , j       , k        , l        ,
     &     ir_s      , ir_e    , !is_s     , is_e     ,
!    &     it_s      , it_e    , iu_s     , iu_e     ,
     &     mao3      , matom   , erithr   , labcd    )
      
      implicit real(8)(a-h,o-z)
      
      integer(8) njtei1cut, njtei2cut
      dimension val_jtei(njtei1cut)
      integer(2) index_jtei(6,njtei1cut)
      
      dimension iaoslix(ir_s:ir_e,3)!,iaosljx(is_s:is_e,3)
!     dimension iaoslkx(it_s:it_e,3),iaosllx(iu_s:iu_e,3)
      dimension e(mao3)
      dimension mm(10)
      data (mm(i),i=1,10) /1,3,6,10,15,21,28,36,45,55/
      
      icc = 0
      do ii=1,mao3
         if (dabs(e(ii)).ge.erithr) then
            icc = 1
            goto 1234
         endif
      enddo
      
 1234 if (icc.eq.0) goto 1111
      
      mi = mm(iangi)
      mj = mm(iangj)
      mk = mm(iangk)
      ml = mm(iangl)
      
!     iouts = 1 !+ iaoslix(i,1)
!     jouts = 1 !+ iaosljx(j,1)
!     kouts = 1 !+ iaoslkx(k,1)
!     louts = 1 !+ iaosllx(l,1)
!     
!     ioute = mi! - iaoslix(i,3)
!     joute = mj! - iaosljx(j,3)
!     koute = mk! - iaoslkx(k,3)
!     loute = ml! - iaosllx(l,3)
      
      m4 = mj * mk * ml
      m3 =      mk * ml
      m2 =           ml

      nn1 = iaoslix(i,2) - 1
      nn2 = iaoslix(j,2) - 1
      nn3 = iaoslix(k,2) - 1
      nn4 = iaoslix(l,2) - 1
!     nn2 = iaosljx(j,2) - 1
!     nn3 = iaoslkx(k,2) - 1
!     nn4 = iaosllx(l,2) - 1
      
      select case(labcd)
      case(0)
         do io = 1,mi
            n1 = nn1 + io
            iki = m4 * (io-1)
            do jo = 1,mj
               n2 = nn2 + jo
               ikj = iki + m3 * (jo-1)
               
               do ko = 1,mk
                  n3 = nn3 + ko
                  ikk = ikj + m2 * (ko-1)
                  do lo = 1,ml
                     n4 = nn4 + lo
                     key = 1
                     iky = ikk + lo
                     now = (iky-1) * 3
                     
                     do mo = 1,3
                        
                        new = now + mo !key
                        
                        if (dabs(e(new)).ge.erithr) then
                           
                           njtei2cut = njtei2cut + 1
                           index_jtei(1,njtei2cut) = n1
                           index_jtei(2,njtei2cut) = n2
                           index_jtei(3,njtei2cut) = n3
                           index_jtei(4,njtei2cut) = n4
                           index_jtei(5,njtei2cut) = matom
                           index_jtei(6,njtei2cut) = mo
                           val_jtei(njtei2cut)  = e(new)
                           
                        endif
                        
!     key = key + 1
                        
                     enddo
                  enddo
               enddo
            enddo
            
         enddo
         
      case(1)
         do io = 1,mi
            n1 = nn1 + io
            iki = m4 * (io-1)
            do jo = 1,mj
               n2 = nn2 + jo
               ikj = iki + m3 * (jo-1)
               
               do ko = 1,mk
                  n3 = nn3 + ko
                  ikk = ikj + m2 * (ko-1)
                  do lo = 1,ml
                     n4 = nn4 + lo
                     key = 1
                     iky = ikk + lo
                     now = (iky-1) * 3
                     
                     do mo = 1,3
                        
                        new = now + mo !key
                        if (n1.lt.n3) cycle !goto 777
                        if ( (n1.eq.n3).and.(n2.lt.n4) ) cycle !goto 777
                        
                        
                        if (dabs(e(new)).ge.erithr) then
                           
                           njtei2cut = njtei2cut + 1
                           index_jtei(1,njtei2cut) = n1
                           index_jtei(2,njtei2cut) = n2
                           index_jtei(3,njtei2cut) = n3
                           index_jtei(4,njtei2cut) = n4
                           index_jtei(5,njtei2cut) = matom
                           index_jtei(6,njtei2cut) = mo
                           val_jtei(njtei2cut)  = e(new)
                           
 777                    endif
                        
!     key = key + 1
                        
                     enddo
                  enddo
               enddo
            enddo
         enddo
         
      case(2)
         do io = 1,mi
            n1 = nn1 + io
            iki = m4 * (io-1)
            do jo = 1,mj
               n2 = nn2 + jo
               ikj = iki + m3 * (jo-1)
               
               do ko = 1,mk
                  n3 = nn3 + ko
                  ikk = ikj + m2 * (ko-1)
                  do lo = 1,ml
                     n4 = nn4 + lo
                     key = 1
                     iky = ikk + lo
                     now = (iky-1) * 3
                     
                     do mo = 1,3
                        
                        new = now + mo !key
                        
                        if (n3.lt.n4) cycle !goto 776
                        if (dabs(e(new)).ge.erithr) then
                           
                           
                           njtei2cut = njtei2cut + 1
                           index_jtei(1,njtei2cut) = n1
                           index_jtei(2,njtei2cut) = n2
                           index_jtei(3,njtei2cut) = n3
                           index_jtei(4,njtei2cut) = n4
                           index_jtei(5,njtei2cut) = matom
                           index_jtei(6,njtei2cut) = mo
                           val_jtei(njtei2cut)  = e(new)
                           
 776                    endif
                        
!     key = key + 1
                        
                     enddo
                  enddo
               enddo
            enddo
         enddo
         
      case(4:5)
         do io = 1,mi
            n1 = nn1 + io
            iki = m4 * (io-1)
            do jo = 1,mj
               n2 = nn2 + jo
               ikj = iki + m3 * (jo-1)
               
               do ko = 1,mk
                  n3 = nn3 + ko
                  ikk = ikj + m2 * (ko-1)
                  do lo = 1,ml
                     n4 = nn4 + lo
                     key = 1
                     iky = ikk + lo
                     now = (iky-1) * 3
                     
                     do mo = 1,3
                        
                        new = now + mo !key
                        
                        if (n1.lt.n2) cycle !goto 775
                        if (dabs(e(new)).ge.erithr) then
                           
                           
                           njtei2cut = njtei2cut + 1
                           index_jtei(1,njtei2cut) = n1
                           index_jtei(2,njtei2cut) = n2
                           index_jtei(3,njtei2cut) = n3
                           index_jtei(4,njtei2cut) = n4
                           index_jtei(5,njtei2cut) = matom
                           index_jtei(6,njtei2cut) = mo
                           val_jtei(njtei2cut)  = e(new)
                           
!     write(80,14)n1,n2,n3,n4,matom,mo,e(new)
 775                    endif
                        
!     key = key + 1
                        
                     enddo
                  enddo
               enddo
            enddo
         enddo
         
      case(6)
         do io = 1,mi
            n1 = nn1 + io
            iki = m4 * (io-1)
            do jo = 1,mj
               n2 = nn2 + jo
               ikj = iki + m3 * (jo-1)
               
               do ko = 1,mk
                  n3 = nn3 + ko
                  ikk = ikj + m2 * (ko-1)
                  do lo = 1,ml
                     n4 = nn4 + lo
                     key = 1
                     iky = ikk + lo
                     now = (iky-1) * 3
                     
                     do mo = 1,3
                        
                        new = now + mo !key
                        if (n1.lt.n2) cycle !goto 773
                        if (n3.lt.n4) cycle !goto 773
                        
                        if (dabs(e(new)).ge.erithr) then
                           
                           njtei2cut = njtei2cut + 1
                           index_jtei(1,njtei2cut) = n1
                           index_jtei(2,njtei2cut) = n2
                           index_jtei(3,njtei2cut) = n3
                           index_jtei(4,njtei2cut) = n4
                           index_jtei(5,njtei2cut) = matom
                           index_jtei(6,njtei2cut) = mo
                           val_jtei(njtei2cut)  = e(new)
                           
!     write(81,14)n1,n2,n3,n4,matom,mo,e(new)
 773                    endif
                        
!     key = key + 1
                        
                     enddo
                  enddo
               enddo
            enddo
         enddo
      end select
      
 14   format (6i4,E26.15)
      
 1111 end
CC JTOUTOS ==========================================================
C  OUTPUT : FOR O-S METHOD
C ===================================================================
      
      subroutine jtoutos (
     &     index_jtei,  val_jtei,  njtei1cut,  njtei2cut,
     &     e         ,
     &     iaoslix   ,  !iaosljx ,  iaoslkx  ,  iaosllx  ,
     &     i         ,  j       ,  k        ,  l        ,
     &     iatom     ,  jatom   ,  katom    ,  latom    ,
     &     ian       ,  jan     ,  kan      ,  lan      ,
     &     ir_s      ,  ir_e    ,  !is_s     ,  is_e     ,
!     &     it_s      ,  it_e    ,  iu_s     ,  iu_e     ,
     &     mao3      ,  erithr  ,
c$$$     &     lerr      ,  lpout  )
     &     lerr)

      implicit real(8)(a-h,o-z)

      dimension iaoslix(ir_s:ir_e,3)!,iaosljx(is_s:is_e,3)
!      dimension iaoslkx(it_s:it_e,3),iaosllx(iu_s:iu_e,3)
      dimension e(mao3,4)
      integer(8) njtei1cut,  njtei2cut
      dimension val_jtei(njtei1cut)
      integer(2) index_jtei(6,njtei1cut)
      dimension mm(10)
      data (mm(i),i=1,10) /1,3,6,10,15,21,28,36,45,55/
 
      
      mi = mm(ian)
      mj = mm(jan)
      mk = mm(kan)
      ml = mm(lan)

!     iouts = 1 !+ iaoslix(i,1)
!     jouts = 1 !+ iaosljx(j,1)
!     kouts = 1 !+ iaoslkx(k,1)
!     louts = 1 !+ iaosllx(l,1)

!     ioute = mi! - iaoslix(i,3)
!     joute = mj! - iaosljx(j,3)
!     koute = mk! - iaoslkx(k,3)
!     loute = ml! - iaosllx(l,3)
     
      i1 = iaoslix(i,2)
      j1 = iaoslix(j,2)
      k1 = iaoslix(k,2)
      l1 = iaoslix(l,2)

      i2 = i1 + mi - 1
      j2 = j1 + mj - 1
      k2 = k1 + mk - 1
      l2 = l1 + ml - 1
 
      m4 = mj * mk * ml
      m3 =      mk * ml
      m2 =           ml

      do im=1,4
         select case(im)
      case(1)
         matom = iatom
      case(2)
         matom = jatom
      case(3)
         matom = katom
      case(4)
         matom = latom
      end select

      do io = 1,mi
!     do io = i1,i2
         n1 = i1 + io - 1
         iki = m4 * (io-1) 
!        iki = m4 * (io-i1) 
         do jo = 1,mj 
!        do jo = j1,j2 
            n2 = j1 + jo - 1
            
            ikj = iki + m3 * (jo-1) 
!           ikj = iki + m3 * (jo-j1) 
            do ko = 1,mk 
!           do ko = k1,k2 
               n3 = k1 + ko - 1
               ikk = ikj + m2 * (ko-1)
!              ikk = ikj + m2 * (ko-k1)
               do lo = 1,ml
!              do lo = l1,l2
                  n4 = l1 + lo - 1

                  key = 1
                  iky = ikk + lo
                  now = (iky-1)*3
                  do mo = 1,3
                     
                     new = now + key
                     
                     if (dabs(e(new,im)).ge.erithr) then
                        
                        njtei2cut = njtei2cut + 1
                        index_jtei(1,njtei2cut) = n1
                        index_jtei(2,njtei2cut) = n2
                        index_jtei(3,njtei2cut) = n3
                        index_jtei(4,njtei2cut) = n4
                        index_jtei(5,njtei2cut) = matom
                        index_jtei(6,njtei2cut) = mo
                        val_jtei(njtei2cut)  = e(new,im)
                     endif

                     key = key + 1

                  enddo
               enddo
            enddo
         enddo
      enddo

      enddo

 14   format (6i4,E26.15)
      end

CC JTOUTOS_all ==========================================================
C  OUTPUT : FOR O-S METHOD
C ===================================================================

      subroutine jtoutos_all (
     &     index_jtei,  gval,  njtei1cut,  num,
     &     e         ,
     &     iaoslix   ,  nshell,
     &     i         ,  j       ,  k        ,  l        ,
     &     iatom     ,  jatom   ,  katom    ,  latom    ,
     &     ian       ,  jan     ,  kan      ,  lan      ,
     &     mao3      ,  erithr  ,
     &     lerr         )

      use integral_hgp_table_class
      implicit real(8)(a-h,o-z)

      dimension iaoslix(nshell,3)
      dimension e(mao3,6)
      dimension gval(njtei1cut)
      integer(2) :: index_jtei(6,njtei1cut)
      integer :: ish(4),iat(4)
      
      type(grad_table)::index_gtei
      dimension mm(10)
      
      data (mm(i),i=1,10) /1,3,6,10,15,21,28,36,45,55/
      
      gval = 0.d0
      num = 0

      ish(1) = i
      ish(2) = j
      ish(3) = k
      ish(4) = l

      iat(1) = iatom
      iat(2) = jatom
      iat(3) = katom
      iat(4) = latom
      
      iout_type = 0
      if (i == j) then
         iout_type = 1
         if (k == l) iout_type = 3
         if (k == l .and. i == k) iout_type = 5
      else
         if (k == l) iout_type=2
         if (j == l .and. i==k ) iout_type = 4
      endif

      call jatom_type(iat,index_gtei)
!     print *,iout_type
      select case(iout_type)
      case(0)
         call grad_output0(gval,index_jtei,e,mao3,iat,num,index_gtei,
     +        ish,ian,jan,kan,lan,erithr,iaoslix,nshell)
      case(1)
         call grad_output1(gval,index_jtei,e,mao3,iat,num,index_gtei,
     +        ish,ian,jan,kan,lan,erithr,iaoslix,nshell)
      case(2)
         call grad_output2(gval,index_jtei,e,mao3,iat,num,index_gtei,
     +        ish,ian,jan,kan,lan,erithr,iaoslix,nshell)
      case(3)
         call grad_output3(gval,index_jtei,e,mao3,iat,num,index_gtei,
     +        ish,ian,jan,kan,lan,erithr,iaoslix,nshell)
      case(4)
         call grad_output4(gval,index_jtei,e,mao3,iat,num,index_gtei,
     +        ish,ian,jan,kan,lan,erithr,iaoslix,nshell)
      case(5)
         print *,"error"
      end select
      
!     do i = 1,num
!     write(80,"(6i4,e26.15)")index_jtei(:,i),gval(i)
!     write(6,"(6i4,e26.15)")index_jtei(:,i),gval(i)
!     enddo
      
      end
