! -*- coding: utf-8 -*-
!
! Dual licensed under the MIT or GPL Version 3 license.
! See 'LICENSE.MIT' for the definition of the MIT license,
! and 'COPYING' for the definition of the GPL license.
!
! == IPRPARA ========================================================
! set parameter for tei calc before assignment range
! ===================================================================

      subroutine iprepara(
     o     zetpq   ,  zz2     ,  nang2n ,  e_rrrr, 
     &     mik     ,
     &     zz      ,  cc      , 
     &     nsh2shty,  nsh2ssh,  nsh2asp,  ntprm ,  ntshty,
     &     nshell  ,  mxsa    ,  nasp   ,  mxprm , 
     &     ierr      )
c$$$      use pl_prof_class

      implicit real(8)(a-h,o-z)

      dimension zetpq(mxprm,mxprm,mxsa,nasp,mxsa,nasp)
      dimension nang2n(5,5,5,5)
      dimension e_rrrr(nshell)

      dimension nsh2shty(nshell)
      dimension zz(mxprm,mxsa,nasp),cc(mxprm,mxsa,nasp)
      dimension nsh2ssh(nshell),nsh2asp(nshell)
      dimension ntprm(mxsa,nasp),ntshty(mxsa,nasp)
      dimension zz2(mxprm,mxsa,nasp)

!     call iset_mm(mm)

      call ipara_zet(mxsa,nasp,mxprm,zz,zetpq)

      call ipara_zz2(zz2,zz,mxsa,nasp,mxprm)

      call iset_nang2n(nang2n,5)

      call swz_rrrr(
     &     e_rrrr ,
     &     nsh2ssh,  nsh2asp,  ntprm,  ntshty,
     &     zz     ,  cc     ,
     &     nshell ,  mxsa   ,  nasp ,  mxprm , 
     &     ierr    )

      call iget_mxshtya(mxxang0,nshell,nsh2shty)

      call iget_bufsize (mrk,mik,mxxang0,1)

      end
